# -*- coding: utf-8
# Copyright 2001, 2002 by IVA Team and contributors
#
# This file is part of IVA.
#
# IVA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# IVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with IVA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import AccessControl
import OFS, Globals
import types
import YlTest
#import TestiYlesanne
from OFS import SimpleItem
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft
from common import translate


class YlVahendus(
     Persistent,
     OFS.SimpleItem.Item,
     Traversable,
     AccessControl.Role.RoleManager,
     Cruft     
     ):
     "lesannete import/eksport, loomine"
     ylesanneteTyybid=("ValikYlesanne","TekstivastusegaYlesanne",
      "YksikvalikYlesanne", "MitmikvalikYlesanne", 
      "OigeTekstivastusegaYlesanne", "ArvuvahemikuliseVastusegaYlesanne",
      "ProtsentYlesanne", "VastavusYlesanne")
     
     def ylesanneteTolkegaTyybid2(self, REQUEST):
        "lesannete tbid tlgituna, vana koopia"
        tulemus={
          "ValikYlesanne": REQUEST['L_it_check_exercise'],
          "TekstivastusegaYlesanne": REQUEST['L_it_text_answer_exercise'],
          "YksikvalikYlesanne": REQUEST['L_it_one_answer_exercise'],
          "MitmikvalikYlesanne": REQUEST['L_it_multiple_choice_exercise'],
          "OigeTekstivastusegaYlesanne": REQUEST['L_it_one_answer'],
          "ArvuvahemikuliseVastusegaYlesanne": REQUEST["L_it_number_space_exercise"],
          "ProtsentYlesanne": REQUEST["L_it_percent_excercise"] ,
          "VastavusYlesanne": REQUEST["L_it_matching_exercise"],
        }
        return tulemus
        
     def ylesanneteTolkegaTyybid(self, REQUEST):
       "Tbid tlgituna, ZPT tarbeks"
       tulemus={
         "ValikYlesanne": translate(self, 'check_exercise', target=self.giveLanguage(REQUEST)),
         "TekstivastusegaYlesanne": translate(self, 'text_answer_exercise', target=self.giveLanguage(REQUEST)),
         "YksikvalikYlesanne": translate(self, 'one_answer_exercise', target=self.giveLanguage(REQUEST)),
         "MitmikvalikYlesanne": translate(self, 'multiple choice', target=self.giveLanguage(REQUEST)),
         "OigeTekstivastusegaYlesanne": translate(self, 'one answer', target=self.giveLanguage(REQUEST)),
         "ArvuvahemikuliseVastusegaYlesanne": translate(self, 'number space', target=self.giveLanguage(REQUEST)),
         "ProtsentYlesanne": translate(self, 'percent exercise', target=self.giveLanguage(REQUEST)),
         "VastavusYlesanne": translate(self, 'matcing exercise', target=self.giveLanguage(REQUEST))
       }
       return tulemus

     def tekstistYlesanneteLaadimiseVorm(self, REQUEST):
        "Tekstiala sisestuseks"
        tulemus=YlTest.leheAlgus(self, REQUEST)+\
          "<form action='tekstistYlesanneteSalvestus'>"+\
          "<textarea name='tekst'></textarea>"+\
          "<input type='submit' value='Saada' />"+\
          "</form><br />"+\
          "<form action='tekstiFailistYlesanneteSalvestus' method='post' enctype='multipart/form-data'>"+\
          "<input type='file' name='fail' />"+\
          "<input type='submit' value='Saada' />"+\
          "</form><br />"+YlTest.leheLopp(self, REQUEST)
        return tulemus
        
     def tekstistYlesanneteSalvestus(self, REQUEST, tekst):
        "Salvestus tase krgemale"
        #self.tekstistYlesanneteMassiiv(tekst)
        #return "kalake"
        self.aq_parent.lisaYlesanded(self.tekstistYlesanneteMassiiv(tekst))
        #return "algus2"
        REQUEST.RESPONSE.redirect('../index_html')
        
     def tekstiFailistYlesanneteSalvestus(self, fail, REQUEST):
        "Failist lisamine tase krgemale"
#        return fail.readline()
        self.aq_parent.lisaYlesanded(self.tekstiRidadestYlesanneteMassiiv(fail.readlines()))
        REQUEST.RESPONSE.redirect('../index_html')
        
          
     def tekstistYlesanneteMassiiv(self, tekst):
        "HotPotatose vljundist lugemine"
        reamassiiv=tekst.split("\n")
        return self.tekstiRidadestYlesanneteMassiiv(reamassiiv)
        
     def tekstiRidadestYlesanneteMassiiv(self, reamassiiv):
        "Read sees massiivina"
        algus=0
        ylesanded=[]
        while algus<len(reamassiiv) and (reamassiiv[algus].split(":"))[1]!="TYPE":
          algus=algus+1
        if algus>=len(reamassiiv):return ylesanded
        while algus<len(reamassiiv):
         ots=algus+1
         while ots<len(reamassiiv) and (len(reamassiiv[ots].split(":"))<2 or (reamassiiv[ots].split(":"))[1]!="TYPE") :
          ots=ots+1
         ylesanded.append(self.tekstiRidadestYlesanne(reamassiiv[algus:ots]))
         algus=ots
        return ylesanded
          
                
     def tekstiRidadestYlesanne(self, reamassiiv):
        "Saabunud ridade phjal lesanne"
        from YlTyybid import *
        yl=None
        tyyp=self.tekstistYlesandeTyyp(reamassiiv)
        if tyyp=="OigeTekstivastusegaYlesanne":
          yl=OigeTekstivastusegaYlesanne('')
        if yl is not None:
          yl.loeTekstistYlesanne(reamassiiv)
        return yl
        
        
     def tekstistYlesandeTyyp(self, reamassiiv):
        "Tbi le otsustamine"
        algrida=reamassiiv[0].split(":")
        tyybitahis=algrida[2].strip()
        if not algrida[1]=="TYPE": return "Tyybita Tundmatu"
        if tyybitahis=="MC": return "MitmikvalikYlesanne"
        if tyybitahis=="M": return "VastavusYlesanne"
        if tyybitahis=="S":
          for x in reamassiiv:
            rida=x.split(":")
            if len(rida)>1:
             if rida[1]=="ANSWER1":
              if rida[4]=="0":
                return "OigeTekstivastusegaYlesanne"
              else:
                return "LynkTestYlesanne"
          return "vastuseta S"
        return "SisuTundmatu"


     def ylesanneteTyypideLoetelu(self, REQUEST):
        "Viited lesannete tpidele"
        tulemus="<h3>"+REQUEST["L_it_choosing_exercise_type"]+"</h3>"
        for x in self.ylesanneteTyybid:
          tulemus=tulemus+"\n"+\
            ("<a href='lisaUusYlesanne?tyyp=%s'>%s</a><br />" %  (x, x))
        return tulemus
        
     def ylesanneteTyybidValikuna(self, REQUEST):
       "Valikmen lesannete lisamiseks"
       andmed=self.ylesanneteTolkegaTyybid(REQUEST)
       tulemus="<p></p><h2>"+translate(self, 'editing quiz', target=self.giveLanguage(REQUEST))+"</h2><form action='lisaUusYlesanne'>"+translate(self, 'add exercise', target=self.giveLanguage(REQUEST))+": <select name='tyyp'>\n"
       for x in andmed.keys():
         tulemus=tulemus+"<option value='"+x+"'>"+andmed[x]+"</option>\n"
       tulemus=tulemus+"</select><input type='submit' value='OK'></form>"
       return tulemus
      
        
     def lisaUusYlesanne(self, REQUEST, tyyp):
        "lesande uus eksemplar"
        import YlTyybid
        from YlTyybid import *
        if tyyp=='ValikYlesanne':
          return ValikYlesanne(translate(self, 'check_exercise_default_question', target=self.giveLanguage(REQUEST)))
        if tyyp=='TekstivastusegaYlesanne':
          return TekstivastusegaYlesanne(translate(self, 'text_answer_exercise_default_question',target=self.giveLanguage(REQUEST)) )
        if tyyp=='YksikvalikYlesanne':
          return YksikvalikYlesanne(translate(self, 'L_it_one_answer_default_question', target=self.giveLanguage(REQUEST)))
        if tyyp=='OigeTekstivastusegaYlesanne':
          return OigeTekstivastusegaYlesanne(translate(self, "L_it_one_answer_exercise_default_question", target=self.giveLanguage(REQUEST)))
        if tyyp=='MitmikvalikYlesanne':
          return MitmikvalikYlesanne(translate(self, "L_it_multiple_choice_exercise_default_question", target=self.giveLanguage(REQUEST)))
        if tyyp=='ArvuvahemikuliseVastusegaYlesanne':
          return ArvuvahemikuliseVastusegaYlesanne(translate(self, "L_it_number_space_exercise_default_question", target=self.giveLanguage(REQUEST)))
        if tyyp=='ProtsentYlesanne':
          return ProtsentYlesanne(translate(self, "L_it_percent_exercise_default_question", target=self.giveLanguage(REQUEST))) 
        if tyyp=='VastavusYlesanne':
          return VastavusYlesanne(translate(self, "L_it_matching_exercise_default_question", target=self.giveLanguage(REQUEST)))

Globals.InitializeClass(YlVahendus)
Globals.default__class_init__(YlVahendus)
